DECLARE SUB SPLIT ()
REM *********************************************************************
REM *********************************************************************
REM *****                                                            ****
REM *****       LOW-RES GUI PROGRAM FRAMEWORK AND FONT SYSTEM        ****
REM *****                 BY ALAN YAP CHING FATT                     ****
REM *****                                                            ****
REM *********************************************************************
REM *********************************************************************

DECLARE SUB showhcmdbuttons (x1, y1, cbrangex, cbsx2, cblist$(), CBMAX, BCOL, fcol)
DECLARE SUB showvcmdbuttons (x1, y1, cbrangey, cbsx2, cblist$(), CBMAX, BCOL, fcol)
DECLARE SUB cmdbutton (cbx, cby, cbsx, ltext$, BCOL, fcol)
DECLARE SUB showscroll (stype$, x1, y1, slen, col)
DECLARE SUB showtextbox (tbx, tby, tbsx, textlen, BCOL)
DECLARE SUB hscroll (x1, y1, slen, barlen, col, min, max, value)
DECLARE SUB vscroll (x1, y1, slen, barlen, col, min, max, value)
DECLARE SUB LOADPIC (FLNAME$, PX, PY)
DECLARE SUB box3d (x1, y1, x2, Y2, col)
DECLARE SUB DBOX (title$, x1, y1, x2, Y2, boxcol, barcol, titlecol)
DECLARE SUB LOADMENU (x1, y1, menufile$, menucol, barcol, pastextcol, acttextcol)
DECLARE FUNCTION selectcolor (dbx, dby)
DECLARE FUNCTION displaymenu$ (menuno)
DECLARE FUNCTION listbox (LBX, LBY, lblen, lbrow, ldata$(), lmin, lmax, LBCOL, lbARcol, ptextcol, atextcol)
DECLARE FUNCTION acthcmdbuttons (x1, y1, cbrangex, cbsx2, cblist$(), CBMAX)
DECLARE FUNCTION actvcmdbuttons (x1, y1, cbrangey, cbsx2, cblist$(), CBMAX)
DECLARE FUNCTION acttextbox$ (tbx, tby, tbsx, textlen, fcol)
DECLARE FUNCTION inputg$ (x5, y5, textlen, fcol, BCOL)

REM **** SUPPORTING FONT SYSTEM ****
DECLARE SUB CLOCATE (tempx, tempy)
DECLARE SUB textcolor (tempcol)
DECLARE SUB LOADFONT (fontname$)
DECLARE SUB CPRINT (ltext$)
DECLARE SUB CENTERPRINT (ctx, cty, ltext$, ctsx)
DECLARE FUNCTION tlen (ltext$)
DECLARE FUNCTION clen (char$)

COMMON SHARED maxclen, charhigh, BOLD, textcol, currentx, currenty, vspace
COMMON SHARED menutotal, menuypos, MenuHOTKEY$, menucol$
COMMON SHARED keytrap$, pointer1, pointer2, TEXTBUFFER$

REM *** GLOBAL FONT-ATTRIBUTES ***
DIM SHARED fontdata$(95), starty(95), CHARLEN(95)

REM *** MENU SYSTEM ***
DIM SHARED menuitem$(15, 15), menubarpic$(10), menupath$
DIM SHARED maxmi(10), menucsize(10), menuxpos(10)

FUNCTION acthcmdbuttons (x1, y1, cbrangex, cbsx2, cblist$(), CBMAX)
REM ********************************************************
REM *** ACTIVATE COMMAND BUTTONS - LEFT TO RIGHT        ****
REM ********************************************************
DIM cbsel, cbbar(700), cbpx(10), CBHOTKEY$

REM *** SCAN HOTKEY OF COMMAND BUTTONS ***
FOR g1 = 1 TO CBMAX
   G2 = INSTR(cblist$(g1), "&")
   IF G2 = 0 THEN F$ = CHR$(255) ELSE F$ = UCASE$(MID$(cblist$(g1), G2 + 1, 1))
   CBHOTKEY$ = CBHOTKEY$ + F$
NEXT
keytrap$ = UCASE$(keytrap$)

REM *** AUTO-SET BUTTON SIZE ***
IF cbsx2 = -1 THEN
    FOR g1 = 1 TO CBMAX
        IF tlen(cblist$(g1)) > cbsx2 THEN cbsx2 = tlen(cblist$(g1)) + 20
    NEXT
END IF

REM *** DRAW THE COMMAND BUTTONS FIRST - SIDE BY SIDE ***
IF CBMAX > 1 THEN
    REM *** DISPLAY MORE THAN ONE BUTTONS ***
    FOR gx33 = 0 TO CBMAX - 1
        cbpx(gx33 + 1) = CINT(x1 + (gx33 * ((cbrangex - cbsx2) / (CBMAX - 1))))
    NEXT
END IF

GX$ = STR$(cbsx2 - 14)
GY$ = STR$(charhigh + 1)
cbsel = pointer1

REM *** ACTIVATES THE COMMAND BUTTON ***
GET (cbpx(cbsel) - 2, y1 - 2)-STEP(1, 1), cbbar
gx2 = cbpx(cbsel) - 2
tempx$ = STR$(cbsx2 - 6): tempy$ = STR$(charhigh - 3)

31300

PUT (gx2, y1 - 2), cbbar, PSET
IF cbsel < 1 THEN cbsel = CBMAX
IF cbsel > CBMAX THEN cbsel = 1

gx2 = cbpx(cbsel) - 2
GET (cbpx(cbsel) - 2, y1 - 2)-STEP(cbsx2 + 4, charhigh + 9), cbbar

PSET (cbpx(cbsel) - 2, y1 + 1)
DRAW "c15 e3 r" + tempx$ + "r4 f3 d6 d" + tempy$
DRAW "c8 g3 l" + tempx$ + "l4 h3 u6 u" + tempy$

31310
F$ = UCASE$(INKEY$)
IF F$ = "" THEN F$ = CHR$(254)

IF MID$(F$, 2, 1) = "K" THEN cbsel = cbsel - 1: GOTO 31300
IF MID$(F$, 2, 1) = "M" THEN cbsel = cbsel + 1: GOTO 31300
IF F$ = CHR$(27) THEN g11 = 0: GOTO 31319
IF F$ = CHR$(13) THEN g11 = cbsel: GOTO 31319

g11 = INSTR(CBHOTKEY$, F$)
IF g11 > 0 THEN GOTO 31319

REM **** TRAP USER KEY PRESS ****
IF INSTR(1, keytrap$, "^") AND MID$(F$, 2, 1) = "H" THEN g11 = -ASC("^"): GOTO 31319
IF INSTR(1, keytrap$, "&") AND MID$(F$, 2, 1) = "P" THEN g11 = -ASC("&"): GOTO 31319
IF INSTR(1, keytrap$, F$) THEN g11 = -ASC(F$): GOTO 31319

GOTO 31310

31319
REM **** DONE WITH SELECTION ****
pointer1 = cbsel
acthcmdbuttons = g11
PUT (gx2, y1 - 2), cbbar, PSET


END FUNCTION

FUNCTION acttextbox$ (tbx, tby, tbsx, textlen, fcol)
REM ************************************************
REM **** ACTIVATE THE TEXT-BOX                 *****
REM ************************************************
IF textlen = -1 THEN textlen = CINT((tbsx - 9) / (1 + maxclen + BOLD))
IF tbsx = -1 THEN tbsx = textlen * (maxclen + BOLD + 1) + 9

BCOL = POINT(tbx + 2, tby + 2)
LINE (tbx + 1, tby + 1)-STEP(tbsx - 3, charhigh + 2), BCOL, BF
temp$ = inputg(tbx + 2, tby + 2, textlen, fcol, BCOL)
acttextbox$ = temp$

END FUNCTION

FUNCTION actvcmdbuttons (x1, y1, cbrangey, cbsx2, cblist$(), CBMAX)
REM ********************************************************
REM *** DISPLAY LIST OF COMMAND BUTTONS - TOP - DOWN    ****
REM ********************************************************
DIM cbsel, cbbar(700), cbpy(10), CBHOTKEY$, temptext$

REM *** AUTO-SET BUTTON SIZE ***
IF cbsx2 = -1 THEN
    FOR g1 = 1 TO CBMAX
        IF tlen(cblist$(g1)) > cbsx2 THEN cbsx2 = tlen(cblist$(g1)) + 20
    NEXT
END IF
keytrap$ = UCASE$(keytrap$)

REM *** SCAN HOTKEY OF COMMAND BUTTONS ***
FOR g1 = 1 TO CBMAX
   G2 = INSTR(cblist$(g1), "&")
   IF G2 = 0 THEN F$ = CHR$(255) ELSE F$ = UCASE$(MID$(cblist$(g1), G2 + 1, 1))
   CBHOTKEY$ = CBHOTKEY$ + F$
NEXT

REM *** CALCULATE POSITION OF EACH BUTTON ***
IF CBMAX > 1 THEN
    REM *** DISPLAY MORE THAN ONE BUTTONS ***
    FOR gY33 = 0 TO CBMAX - 1
        cbpy(gY33 + 1) = CINT(y1 + (gY33 * ((cbrangey - (charhigh + 8)) / (CBMAX - 1))))
    NEXT
END IF

cbsel = pointer1
REM *** ACTIVATES THE COMMAND BUTTON ***
GET (x1 - 2, cbpy(cbsel) - 2)-STEP(1, 1), cbbar
GY2 = cbpy(cbsel) - 2

tempx$ = STR$(cbsx2 - 6)
tempy$ = STR$(charhigh - 3)

31400
PUT (x1 - 2, GY2), cbbar, PSET
IF cbsel < 1 THEN cbsel = CBMAX
IF cbsel > CBMAX THEN cbsel = 1

GY2 = cbpy(cbsel) - 2
GET (x1 - 2, cbpy(cbsel) - 2)-STEP(cbsx2 + 4, charhigh + 9), cbbar
PSET (x1 - 2, cbpy(cbsel) + 1)
DRAW "c15 e3 r" + tempx$ + "r4 f3 d6 d" + tempy$
DRAW "c8 g3 l" + tempx$ + "l4 h3 u6 u" + tempy$

31410
F$ = UCASE$(INKEY$)
IF F$ = "" THEN F$ = CHR$(254)
IF MID$(F$, 2, 1) = "H" THEN cbsel = cbsel - 1: GOTO 31400
IF MID$(F$, 2, 1) = "P" THEN cbsel = cbsel + 1: GOTO 31400
IF F$ = CHR$(27) THEN g11 = 0: GOTO 31419
IF F$ = CHR$(13) THEN g11 = cbsel: GOTO 31419

g11 = INSTR(CBHOTKEY$, F$)
IF g11 > 0 THEN GOTO 31419

REM **** TRAP USER KEY PRESS ****
IF INSTR(1, keytrap$, "<") AND MID$(F$, 2, 1) = "K" THEN g11 = -ASC("<"): GOTO 31419
IF INSTR(1, keytrap$, ">") AND MID$(F$, 2, 1) = "M" THEN g11 = -ASC(">"): GOTO 31419
IF INSTR(1, keytrap$, F$) THEN g11 = -ASC(F$): GOTO 31419

GOTO 31410

31419
REM **** DONE WITH SELECTION ****
pointer1 = cbsel
actvcmdbuttons = g11
PUT (x1 - 2, GY2), cbbar, PSET

END FUNCTION

SUB box3d (x1, y1, x2, Y2, col)



LINE (x1 + 2, y1 + 2)-STEP(x2 - 4, Y2 - 4), col, BF
LINE (x1, y1)-STEP(x2, Y2), 8, B
LINE (x1 + 1, y1 + 1)-STEP(x2 - 2, Y2 - 2), 8, B


LINE (x1, y1)-STEP(x2, 0), 15
LINE -STEP(0, Y2), 15
LINE (x1 + 1, y1 + 1)-STEP(x2 - 2, 0), 15
LINE -STEP(0, Y2 - 2), 15



END SUB

SUB CENTERPRINT (ctx, cty, ltext$, ctsx)
REM *****************************************
REM **** Centers and print the font      ****
REM *****************************************
DIM tempx

tempx = CINT((ctsx - tlen(ltext$)) / 2)
currentx = ctx + tempx
currenty = cty
CPRINT ltext$

END SUB

FUNCTION clen (char$)
REM ****** RETURN THE LENGTH OF A CHARACTER ******
clen = CHARLEN(ASC(char$) - 32)

END FUNCTION

SUB CLOCATE (tempx, tempy)
currentx = tempx
currenty = tempy
END SUB

SUB cmdbutton (cbx, cby, cbsx, ltext$, BCOL, fcol)
REM ****************************************
REM *** DISPLAY A COMMAND BUTTON         ***
REM ****************************************
DIM cbsy, tempx$, tempy$

cbsy = charhigh + 5
REM *** AUTO ADJUST BUTTON ***
IF cbsx = -1 THEN cbsx = tlen(ltext$) + 20


REM *** DRAW OUTLINES OF COMMAND BUTTON ****
tempx$ = STR$(cbsx - 4)
tempy$ = STR$(cbsy - 4)
LINE (cbx + 1, cby + 1)-STEP(cbsx - 2, cbsy - 2), BCOL, BF
PSET (cbx, cby + 2), 0
DRAW "e2 r" + tempx$ + " f2 d" + tempy$
DRAW " g2 l" + tempx$ + " h2 u" + tempy$
PSET (cbx + 1, cby + 2), 0
DRAW "c15 ru r" + tempx$ + " dr d" + tempy$
DRAW "c8 ld l" + tempx$ + " ul u" + tempy$

textcol = fcol
CENTERPRINT cbx + 1, cby + 3, ltext$, cbsx


END SUB

SUB CPRINT (ltext$)

REM **************************************************
REM **** DISPLAY OUT THE TEXT USING LOADED FONTS  ****
REM **************************************************
GX = 0

FOR g1 = 1 TO LEN(ltext$)
    c$ = MID$(ltext$, g1, 1)
    G2 = ASC(c$) - 32
    IF c$ = "&" THEN
             c$ = MID$(ltext$, g1 + 1, 1)
             LINE (currentx + GX, currenty - 1 + charhigh)-STEP(CHARLEN(ASC(c$) - 32) - 1 + BOLD, 0), textcol
             G3 = -1
        ELSEIF c$ <> " " THEN
            G3 = CHARLEN(G2) + BOLD
            PSET (currentx + GX, currenty - 1 + starty(G2)), textcol: DRAW fontdata$(G2)
            IF BOLD > 0 THEN PSET (currentx + GX + 1, currenty - 1 + starty(G2)), textcol: DRAW fontdata$(G2)
          ELSE
            G3 = CHARLEN(0) + BOLD
    END IF
    GX = CINT(GX + G3 + 1)
NEXT

currenty = currenty + charhigh + vspace


END SUB

SUB DBOX (title$, x1, y1, x2, Y2, boxcol, barcol, titlecol)
REM ******************************************
REM ******** DRAWS A WIN99 DIALOG BOX ********
REM ******************************************
DIM barsy, x3

LINE (x1, y1)-STEP(x2 - 1, Y2 - 1), boxcol, BF
LINE (x1, y1)-STEP(x2 - 1, Y2 - 1), 8, B
LINE (x1, y1)-STEP(x2 - 1, 0), 15
LINE -STEP(0, Y2 - 1), 15

REM *** SHADED BOX AND BAR ***
FOR GX = 1 TO 4
    g11 = boxcol + GX
    LINE (x1 + 5 - GX, y1 + 1)-STEP(0, Y2 - 3), g11
    LINE (x1 + x2 - 6 + GX, y1 + 1)-STEP(0, Y2 - 3), g11
NEXT

FOR GX = 1 TO 3
    g11 = barcol - GX
    LINE (x1 + 3, y1 + 6 - GX)-STEP(x2 - 7, 0), g11
    LINE (x1 + 3, y1 + charhigh + GX)-STEP(x2 - 7, 0), g11
NEXT

barsy = charhigh + 2
x3 = x1 + x2

REM **** DISPLAY TITLE BAR ********
LINE (x1 + 3, y1 + 6)-STEP(x2 - 7, charhigh - 6), barcol, BF
temp$ = "c15 d" + STR$(barsy) + "r c8 u" + STR$(barsy)
LINE (x1 + 3, y1 + 2)-STEP(x2 - 7, barsy), 8, B
LINE (x1 + 3, y1 + 2)-STEP(x2 - 7, 0), 15
LINE -STEP(0, barsy), 15

 PSET (x1 + 5, y1 + 2): DRAW temp$
 PSET (x1 + 9, y1 + 2): DRAW temp$
 PSET (x3 - 11, y1 + 2): DRAW temp$
 PSET (x3 - 7, y1 + 2): DRAW temp$

textcol = titlecol
CLOCATE x1 + 12, y1 + 4: CPRINT title$

LINE (x1 + 1, y1 + barsy + 4)-STEP(x2 - 2, 0), 8
LINE (x1 + 1, y1 + barsy + 5)-STEP(x2 - 2, 0), 15

END SUB

FUNCTION displaymenu$ (menuno)
REM ************************************************
REM **** DISPLAY AND ACTIVATE MENUBOX          *****
REM ************************************************
DIM MENUX, MENUY, menusx, MENUSY, menuttx, menutty
DIM menusel, menuitembar(400), mirhigh, MIHOTKEY$
DIM menucol, menubarcol, acttext, pasttext
DIM im1(5000)

31100
IF menuno < 1 THEN menuno = menutotal
IF menuno > menutotal THEN menuno = 1
G2 = 0
menusel = 1
mirhigh = charhigh + 3
MENUX = menuxpos(menuno)
MENUY = menuypos
menuttx = MENUX
menutty = MENUY - (charhigh + 4)

menucol = ASC(LEFT$(menucol$, 1))
menubarcol = ASC(MID$(menucol$, 2, 1))
pastextcol = ASC(MID$(menucol$, 3, 1))
acttextcol = ASC(RIGHT$(menucol$, 1))


REM *** HIGHLIGHT ACTIVE MENUTITLE ****
F$ = STR$(tlen(menuitem$(menuno, 0)) + 6)
GY = charhigh + 3
GET (menuttx, menutty)-STEP(VAL(F$), GY), menuitembar

LINE (menuttx, menutty)-STEP(tlen(menuitem$(menuno, 0)) + 6, GY), menubarcol, BF
PSET (menuttx, menutty)
DRAW "C15 r" + F$ + " d" + STR$(GY) + "c8 l" + F$ + " u" + STR$(GY)
textcol = acttextcol
CLOCATE menuttx + 4, menutty + 2: CPRINT menuitem$(menuno, 0)

REM *** DRAW THE MENUBOX ****
IF menubarpic$(menuno) = "" THEN
    MENUBX1 = 0: MENUBX2 = 5
  ELSE
    OPEN "I", #1, menupath$ + menubarpic$(menuno) + ".txt"
    INPUT #1, F$, g1, G2
    CLOSE #1
    MENUBX1 = g1: MENUBX2 = g1
END IF

menusx = menucsize(menuno) + 8 + (4 * CHARLEN(0)) + MENUBX1
MENUSY = (maxmi(menuno) * (mirhigh)) + 7
IF MENUX + menusx > 319 THEN MENUX = menuttx - (menusx - VAL(F$))
IF MENUY + MENUSY > 199 THEN MENUY = menutty - MENUSY
GET (MENUX, MENUY)-STEP(menusx, MENUSY), im1
LINE (MENUX, MENUY)-STEP(menusx, MENUSY), menucol, BF
LINE (MENUX, MENUY)-STEP(menusx, MENUSY), 8, B
LINE (MENUX, MENUY)-STEP(menusx, 0), 15
LINE -STEP(0, MENUSY), 15

REM **** PUT IN SIDEBAR (IF ANY) ****
IF menubarpic$(menuno) <> "" THEN
    GY = MENUY + MENUSY - (G2 + 2)
    LOADPIC menupath$ + menubarpic$(menuno), MENUX + 2, GY
    G3 = POINT(MENUX + 3, GY)
    LINE (MENUX + 2, MENUY + 2)-(MENUX + 1 + g1, GY), G3, BF
END IF

REM *** SCAN HOTKEY OF COMMAND BUTTONS ***
MIHOTKEY$ = ""
FOR g1 = 1 TO maxmi(menuno)
   G2 = INSTR(menuitem$(menuno, g1), "&")
   IF G2 = 0 THEN F$ = CHR$(255) ELSE F$ = UCASE$(MID$(menuitem$(menuno, g1), G2 + 1, 1))
   MIHOTKEY$ = MIHOTKEY$ + F$
NEXT

REM *** PUT IN MENUITEMS ***
textcol = pastextcol
FOR GY = 1 TO maxmi(menuno)
    CLOCATE MENUX + MENUBX2 + (CHARLEN(0) * 2), MENUY + 7 + ((GY - 1) * mirhigh)
    CPRINT menuitem$(menuno, GY)
NEXT

GOSUB 31150

REM ***** ACTIVATE THE MENU CONTROL SYSTEM ****
31110
F$ = UCASE$(INKEY$)
IF F$ = "" THEN F$ = CHR$(254)
IF MID$(F$, 2, 1) = "H" THEN GOSUB 31140: menusel = menusel - 1: GOSUB 31150
IF MID$(F$, 2, 1) = "P" THEN GOSUB 31140: menusel = menusel + 1: GOSUB 31150
IF MID$(F$, 2, 1) = "K" THEN GOSUB 31160: menuno = menuno - 1: GOTO 31100
IF MID$(F$, 2, 1) = "M" THEN GOSUB 31160: menuno = menuno + 1: GOTO 31100
IF F$ = CHR$(27) OR F$ = CHR$(13) THEN GOTO 31190
G2 = INSTR(MIHOTKEY$, F$)
IF G2 > 0 THEN menusel = G2: GOTO 31190

GOTO 31110

REM *** REMOVE MENUBAR ***
31140
GY = (menusel - 1) * mirhigh
LINE (MENUX + MENUBX1 + 3, MENUY + GY + 4)-STEP(menusx - 6 - MENUBX1, mirhigh), menucol, BF
textcol = pastextcol
CLOCATE MENUX + MENUBX2 + (CHARLEN(0) * 2), MENUY + GY + 7: CPRINT menuitem$(menuno, menusel)
RETURN

REM *** REDRAW MENUBAR ***
31150
IF menusel < 1 THEN menusel = maxmi(menuno)
IF menusel > maxmi(menuno) THEN menusel = 1
GY = (menusel - 1) * mirhigh
LINE (MENUX + MENUBX1 + 4, MENUY + GY + 5)-STEP(menusx - 8 - MENUBX1, mirhigh - 2), menubarcol, BF
LINE (MENUX + MENUBX1 + 3, MENUY + GY + 4)-STEP(menusx - 6 - MENUBX1, mirhigh), 8, B
LINE (MENUX + MENUBX1 + 4, MENUY + GY + 4)-STEP(menusx - 7 - MENUBX1, 0), 15
LINE -STEP(0, mirhigh - 1), 15
textcol = acttextcol
CLOCATE MENUX + MENUBX2 + (CHARLEN(0) * 2), MENUY + GY + 7: CPRINT menuitem$(menuno, menusel)
RETURN

REM *** CLEAR MENUBOX ***
31160
PUT (MENUX, MENUY), im1, PSET
PUT (menuttx, menutty), menuitembar, PSET
RETURN

REM *** EXIT THIS SUBROUTINES ****
31190
GOSUB 31160
IF F$ = CHR$(27) THEN
        displaymenu$ = CHR$(27)
    ELSE
        displaymenu$ = LTRIM$(RTRIM$(STR$(menuno))) + "." + LTRIM$(RTRIM$(STR$(menusel)))
END IF

END FUNCTION

SUB hscroll (x1, y1, slen, barlen, col, min, max, value)
REM ***********************************
REM ** UPDATES HORIZONTAL SCROLL    ***
REM ***********************************

REM ** UPDATE BAR SKELETON ***
LINE (x1 + 12, y1)-STEP(slen - 25, 11), 24, BF
LINE (x1 + 11, y1)-STEP(slen - 24, 11), 0, B
LINE (x1 + 12, y1 + 1)-STEP(slen - 25, 9), 15, B
LINE (x1 + 12, y1 + 1)-STEP(slen - 25, 0), 8
LINE -STEP(0, 9), 8

REM *** DRAW THE BAR POINTER ***
blen$ = STR$(barlen - 1)
aval = CINT((value - min) / (max - min) * (slen - 24 - barlen))
LINE (x1 + 12 + aval, y1 + 1)-STEP(barlen - 1, 9), 0, B
PSET (x1 + 12 + aval, y1 + 1):   DRAW "c15 R" + blen$ + "D9 c8 L" + blen$ + "U9"

REM ** SHADED BAR ***
FOR GY1 = 0 TO 3
    LINE (x1 + 13 + aval, y1 + 5 - GY1)-STEP(barlen - 3, 0), col - GY1
    LINE (x1 + 13 + aval, y1 + 5 + GY1)-STEP(barlen - 3, 0), col - GY1
NEXT

END SUB

FUNCTION inputg$ (x5, y5, textlen, fcol, BCOL)
REM *****************************************************
REM *** KINDA LIKE INPUT STATEMENT...JUST MORE FLEXIBLE!
REM *****************************************************
DIM text$, cpos, X6

text$ = TEXTBUFFER$: cpos = 1: X6 = 0
LINE (x5, y5)-STEP(textlen * (maxclen + BOLD + 1) + 5, charhigh), BCOL, BF
REM **** APPEND TO PREVIOUS INPUT ****
IF text$ <> "" THEN
    X6 = tlen(TEXTBUFFER$) + 1
    cpos = LEN(text$) + 1
    textcol = fcol
    CLOCATE x5 + 1, y5 + 1: CPRINT text$
END IF

LINE (x5 + X6 + 1, y5)-STEP(0, charhigh), fcol, B


textcol = fcol
DO UNTIL F$ = CHR$(27) OR F$ = CHR$(13)
    TEXTBUFFER$ = text$
    F$ = INPUT$(1)
    IF F$ = "" OR F$ = "&" THEN F$ = CHR$(255)
   
    ' Enter the font
    IF ASC(F$) >= 32 AND ASC(F$) <= 127 AND cpos <= textlen THEN
        LINE (x5 + X6 + 1, y5)-STEP(0, charhigh), BCOL, B
        text$ = text$ + F$
        cpos = cpos + 1
        IF F$ <> " " THEN
            CLOCATE x5 + X6 + 1, y5 + 1
            CPRINT F$
        END IF

        X6 = X6 + CHARLEN(ASC(F$) - 32) + 1 + BOLD
        LINE (x5 + X6 + 1, y5)-STEP(0, charhigh), fcol, B
    END IF

    ' Backspace
    IF F$ = CHR$(8) AND cpos > 1 THEN
        LINE (x5 + X6 + 1, y5)-STEP(0, charhigh), BCOL, B
        cpos = cpos - 1
        g22 = CHARLEN(ASC(RIGHT$(text$, 1)) - 32) + 1 + BOLD
        X6 = X6 - g22
        LINE (x5 + X6 + 1, y5)-STEP(g22 - 1, charhigh), BCOL, BF
        LINE (x5 + X6 + 1, y5)-STEP(0, charhigh), fcol, B
        text$ = LEFT$(text$, LEN(text$) - 1)
    END IF

    ' Trap user preferred keys
    IF INSTR(1, keytrap$, F$) THEN text$ = "": EXIT DO
LOOP

IF F$ = CHR$(27) THEN text$ = ""
IF text$ = "" THEN inputg$ = F$ ELSE inputg$ = RTRIM$(text$)

END FUNCTION

FUNCTION listbox (LBX, LBY, lblen, lbrow, ldata$(), lmin, lmax, LBCOL, lbARcol, ptextcol, atextcol)
REM ***********************************************
REM *** DISPLAY AND ACTIVATE LISTBOX            ***
REM ***********************************************
DIM LBSX, LBSY, lbcy2, lbcy1, listsel, totalrow

REM **** DRAW OUT THE LISTBOX FIRST ****
keytrap$ = UCASE$(keytrap$)
lbcy1 = pointer1: lbcy2 = pointer2
totalrow = lmax - lmin + 1
lbarsy = charhigh + 3
LBSY = (lbrow * lbarsy) + 2
LBSX = (lblen * maxclen)
IF totalrow <= lbrow THEN LBSX = LBSX - 12
'LINE (LBX, LBY)-STEP(LBSX, LBSY), LBCOL, BF
LINE (LBX, LBY)-STEP(LBSX, LBSY), 15, B
LINE (LBX, LBY)-STEP(LBSX, 0), 8
LINE -STEP(0, LBSY), 8

IF totalrow <= lbrow THEN
    LBSX = LBSX + 12
  ELSE
    CALL showscroll("^", LBX + LBSX - 12, LBY + 1, LBSY - 1, LBCOL)
END IF


IF POINT(LBX + 2, LBY + 2) <> LBCOL THEN GOSUB 31250

REM ***********************************
REM *** ACTIVATING THE LISTBOX     ****
REM ***********************************

31200
REM *** HIGHLIGHT POINTER ****
GY2 = LBY - charhigh + (lbcy2 * lbarsy)
IF lbrow > totalrow THEN lbcy1 = 1
listsel = (lmin - 1) + (lbcy1 - 1) + lbcy2
LINE (LBX + 1, GY2 - 2)-STEP(LBSX - 14, lbarsy), lbARcol, BF
LINE (LBX + 1, GY2 - 2)-STEP(LBSX - 14, lbarsy), 8, B
LINE (LBX + 2, GY2 - 2)-STEP(LBSX - 15, 0), 15
LINE -STEP(0, lbarsy), 15
FOR gy11 = 0 TO 2
    LINE (LBX + 2, GY2 + 1 - gy11)-STEP(LBSX - 16, 0), lbARcol - gy11
    LINE (LBX + 2, GY2 + charhigh - 2 + gy11)-STEP(LBSX - 16, 0), lbARcol - gy11
NEXT
IF INSTR(1, keytrap$, "^") AND MID$(F$, 2, 1) = "H" THEN F$ = "^": listsel = 0: GOTO 31290
IF INSTR(1, keytrap$, "&") AND MID$(F$, 2, 1) = "P" THEN F$ = "&": listsel = 0: GOTO 31290

textcol = atextcol
CLOCATE LBX + 4, GY2: CPRINT ldata$(listsel)

REM *** REFRESH SCROLLBAR ****
IF totalrow > lbrow THEN CALL vscroll(LBX + LBSX - 12, LBY + 1, LBSY - 1, 20, lbARcol, lmin, lmax, listsel)


REM *** ASK USER KEYPRESS ***
31210
F$ = UCASE$(INKEY$)
IF F$ = "" THEN F$ = CHR$(255)

REM **** TRAP USER KEY PRESS ****
IF INSTR(1, keytrap$, "<") AND MID$(F$, 2, 1) = "K" THEN F$ = "<": listsel = -60: GOTO 31290
IF INSTR(1, keytrap$, ">") AND MID$(F$, 2, 1) = "M" THEN F$ = ">": listsel = -62: GOTO 31290
IF INSTR(1, keytrap$, F$) THEN listsel = -1: GOTO 31290

REM **** STANDARD KEY CONTROLS ****
IF MID$(F$, 2, 1) = "H" THEN
  IF lbcy2 = 1 THEN
      IF lbcy1 > 1 THEN lbcy1 = lbcy1 - 1: GOSUB 31250: GOTO 31200
    ELSE
      GOSUB 31230: lbcy2 = lbcy2 - 1: GOTO 31200
  END IF
END IF
IF MID$(F$, 2, 1) = "P" THEN
    IF lbcy2 < lbrow AND lbcy2 < totalrow THEN GOSUB 31230: lbcy2 = lbcy2 + 1: GOTO 31200
    IF lbcy2 = lbrow AND lbcy1 - 1 + lbcy2 < totalrow THEN lbcy1 = lbcy1 + 1: GOSUB 31250: GOTO 31200
END IF

IF F$ = CHR$(27) THEN listsel = -27: GOTO 31290
IF F$ = CHR$(13) THEN GOTO 31290

GOTO 31210

31230
REM *** UNHIGHLIGHT POINTER ******
GY2 = LBY - charhigh + (lbcy2 * lbarsy)
listsel = (lmin - 1) + (lbcy1 - 1) + lbcy2
LINE (LBX + 1, GY2 - 2)-STEP(LBSX - 14, lbarsy), LBCOL, BF
textcol = ptextcol
CLOCATE LBX + 4, GY2: CPRINT ldata$(listsel)
RETURN

31250
REM ****** REDRAW LISTBOX CONTENTS ****
IF lbcy1 < 1 THEN lbcy1 = 1: RETURN
IF lbcy1 > totalrow - (lbrow - 1) AND lbrow <= totalrow THEN lbcy1 = totalrow - (lbrow - 1)
IF lbcy2 > totalrow AND lbrow > totalrow THEN lbcy2 = totalrow
LINE (LBX + 1, LBY + 1)-STEP(LBSX - 14, LBSY - 2), LBCOL, BF
textcol = ptextcol
FOR GY = 1 TO lbrow
    IF GY > totalrow THEN EXIT FOR
    GY2 = LBY - charhigh + (GY * lbarsy)
    G2 = (lmin - 1) + (lbcy1 - 1) + GY
    CLOCATE LBX + 4, GY2: CPRINT ldata$(G2)
NEXT
RETURN

31290
REM ****** EXIT LISTBOX ******
REM ***** SOFTEN THE CURRENT SELECTED LIST ITEM ******
pointer1 = lbcy1: pointer2 = lbcy2
LINE (LBX + 1, GY2 - 2)-STEP(LBSX - 14, lbarsy), LBCOL, BF
LINE (LBX + 1, GY2 - 2)-STEP(LBSX - 14, lbarsy), 15, B
LINE (LBX + 2, GY2 - 2)-STEP(LBSX - 15, 0), 8
LINE -STEP(0, lbarsy), 8
g11 = (lmin - 1) + (lbcy1 - 1) + lbcy2
textcol = lbARcol: CLOCATE LBX + 4, GY2: CPRINT ldata$(g11)
IF listsel < 0 THEN listbox = -(ASC(F$)) ELSE listbox = listsel

END FUNCTION

SUB LOADFONT (fontname$)

REM **************************************
REM *** START LOADING THE FILE!       ****
REM **************************************
DIM text$

OPEN "I", #1, fontname$ + ".FNT"

' Load dummy header
LINE INPUT #1, text$
LINE INPUT #1, text$

' Load Character height
LINE INPUT #1, text$
text$ = RTRIM$(text$)
charhigh = VAL(text$)

' Load Font-data
GY = 1
maxclen = 0
vspace = 2

LINE INPUT #1, text$
text$ = RTRIM$(text$)
DO UNTIL text$ = "[END]" OR EOF(1)
    fontdata$(GY) = RIGHT$(text$, LEN(text$) - 2)
    CHARLEN(GY) = ASC(LEFT$(text$, 1)) - 64
    IF CHARLEN(GY) > maxclen THEN maxclen = CHARLEN(GY)
    starty(GY) = ASC(MID$(text$, 2, 1)) - 64
    GY = GY + 1
    LINE INPUT #1, text$
    text$ = RTRIM$(text$)
LOOP
CLOSE #1
CHARLEN(0) = 4


END SUB

SUB LOADMENU (x1, y1, menufile$, menucol, menubarcol, pastextcol, acttextcol)
REM ************************************************************
REM **** SETUP MENU STRUCTURE                               ****
REM ******************************* *****************************
REM *** DETERMINE PATH OF MENUFILE ***
FOR g1 = LEN(menufile$) TO 1 STEP -1
    IF MID$(menufile$, g1, 1) = "\" THEN EXIT FOR
NEXT
menupath$ = LEFT$(menufile$, g1)

REM **** LOAD MENU ITEMS FROM FILE INTO MEMORY ****
OPEN "I", #1, menufile$ + ".MNU"
menutotal = 0
LINE INPUT #1, D$
DO UNTIL D$ = "[END]"
    menutotal = menutotal + 1
    LINE INPUT #1, D$
    D$ = LTRIM$(RTRIM$(D$))
    IF LEFT$(D$, 2) = "@ " THEN
        menuitem$(menutotal, 0) = RIGHT$(D$, LEN(D$) - 2)
        LINE INPUT #1, menubarpic$(menutotal)
        DO UNTIL D$ = "@"
            maxmi(menutotal) = maxmi(menutotal) + 1
            LINE INPUT #1, D$
            D$ = LTRIM$(RTRIM$(D$))
            IF LEFT$(D$, 2) = "- " THEN menuitem$(menutotal, maxmi(menutotal)) = RIGHT$(D$, LEN(D$) - 2)
            g1 = tlen(menuitem$(menutotal, maxmi(menutotal)))
            IF g1 > menucsize(menutotal) THEN menucsize(menutotal) = g1
        LOOP
    END IF
LOOP

CLOSE #1

D$ = ""
menuxpos(1) = x1 - 4
FOR g1 = 1 TO 10
    maxmi(g1) = maxmi(g1) - 1
     IF g1 > 1 THEN menuxpos(g1) = x1 + tlen(D$) - (g1 + 2)
    D$ = D$ + menuitem$(g1, 0) + "  "
NEXT
menutotal = menutotal - 1
D$ = RTRIM$(D$)
menuypos = y1 + charhigh + 2
MenuHOTKEY$ = ""

FOR g1 = 1 TO LEN(D$)
    IF MID$(D$, g1, 1) = "&" THEN MenuHOTKEY$ = MenuHOTKEY$ + MID$(D$, g1 + 1, 1)
NEXT

REM **** DISPLAY THE MENU BAR ****
CLOCATE x1, y1: CPRINT D$

menucol$ = ""
menucol$ = menucol$ + CHR$(menucol) + CHR$(menubarcol)
menucol$ = menucol$ + CHR$(pastextcol) + CHR$(acttextcol)

END SUB

SUB LOADPIC (FLNAME$, PX, PY)
REM **** LOAD TXT IMAGE ***
OPEN "I", #1, FLNAME$ + ".TXT"
INPUT #1, F$
IF F$ = "<DTXT>" THEN INPUT #1, psizex, psizey ELSE psizex = 70: psizey = 70
GX = POINT(PX, PY)
PSET (PX, PY)
FOR gx1 = 1 TO psizex
     INPUT #1, g1$: DRAW g1$
NEXT
CLOSE #1
PSET (PX, PY), GX
END SUB

FUNCTION selectcolor (dbx, dby)
REM *******************************************************
REM **** LET USER PICK COLOR FROM COLOR PALETTE       *****
REM *******************************************************
REM **** RETURNS THE COLOR SELECTED - (0 TO 15)        ****
REM **** IF USER PRESS ESC, RETURNS -1                 ****
REM *******************************************************

DIM lr, ud
DIM background(2020)       'STORE BACKGROUND IMAGE

REM **** DISPLAY OUT COLOR PALETTE  *****
GET (dbx, dby)-STEP(109, 71), background
BOLD = 1
LINE (dbx, dby)-STEP(109, 71), 27, BF
PSET (dbx, dby): DRAW "c15 r109d71 c23 l109u71"
FOR GX23 = 0 TO 19
  FOR GY23 = 0 TO 9
    GX22 = dbx + 5 + (GX23 * 5)
    GY22 = dby + 18 + (GY23 * 5)
    g11 = (GX23 + (GY23 * 20))
    LINE (GX22, GY22)-STEP(3, 3), g11, BF
    IF g11 = pointer1 THEN GX21 = GX23: GY21 = GY23
  NEXT
NEXT

PSET (dbx + 6, dby + 4): DRAW "c15 r20 d10 c8 l20 u10"

31510
IF GX21 < 0 THEN GX21 = 19: GY21 = GY21 - 1
IF GX21 > 19 THEN GX21 = 0: GY21 = GY21 + 1
IF GY21 < 0 THEN GY21 = 9
IF GY21 > 9 THEN GY21 = 0

GX22 = dbx + 4 + (GX21 * 5)
GY22 = dby + 17 + (GY21 * 5)
PSET (GX22, GY22): DRAW "C15 R5 D5 C8 L5 U5"

g11 = POINT(GX22 + 1, GY22 + 1)
LINE (dbx + 7, dby + 5)-STEP(18, 8), g11, BF
LINE (dbx + 31, dby + 6)-STEP(30, 8), 27, BF
textcol = 1
CLOCATE dbx + 31, dby + 6: CPRINT LTRIM$(STR$(g11))
PSET (GX22, GY22): DRAW "c27"

31511
F$ = UCASE$(INKEY$)
IF MID$(F$, 2, 1) = "H" THEN DRAW "r5d5l5u5": GY21 = GY21 - 1: GOTO 31510
IF MID$(F$, 2, 1) = "P" THEN DRAW "r5d5l5u5": GY21 = GY21 + 1: GOTO 31510
IF MID$(F$, 2, 1) = "K" THEN DRAW "r5d5l5u5": GX21 = GX21 - 1: GOTO 31510
IF MID$(F$, 2, 1) = "M" THEN DRAW "r5d5l5u5": GX21 = GX21 + 1: GOTO 31510
IF F$ = CHR$(27) OR F$ = CHR$(13) THEN GOTO 31519
GOTO 31511


31519
REM *** RESTORE BACKGROUND *****
IF F$ = CHR$(13) THEN selectcolor = g11 ELSE selectcolor = -27
PUT (dbx, dby), background, PSET
BOLD = 0
END FUNCTION

SUB showhcmdbuttons (x1, y1, cbrangex, cbsx2, cblist$(), CBMAX, BCOL, fcol)
REM ********************************************************
REM *** DISPLAY LIST OF COMMAND BUTTONS - LEFT TO RIGHT ****
REM ********************************************************

REM *** AUTO-SET BUTTON SIZE ***
IF cbsx2 = -1 THEN
    FOR g1 = 1 TO CBMAX
        IF tlen(cblist$(g1)) > cbsx2 THEN cbsx2 = tlen(cblist$(g1)) + 20
    NEXT
END IF

REM *** DRAW THE COMMAND BUTTONS FIRST - SIDE BY SIDE ***
IF CBMAX > 1 THEN
    REM *** DISPLAY MORE THAN ONE BUTTONS ***
    FOR gx33 = 0 TO CBMAX - 1
        gy34 = CINT(x1 + (gx33 * ((cbrangex - cbsx2) / (CBMAX - 1))))
        CALL cmdbutton(gy34, y1, cbsx2, cblist$(gx33 + 1), BCOL, fcol)
    NEXT
END IF

END SUB

SUB showscroll (stype$, x1, y1, slen, col)
REM *********************************************
REM *** DISPLAY THE SCROLL                   ****
REM *********************************************
DIM arrow$

text$ = "c15 r9d9 c8 l9u8"

IF stype$ = "^" THEN
    REM *** DRAW TOP,BOTTOM SCROLL BUTTON ***
    arrow$ = "c0 l5dr5g l3f r"
    LINE (x1, y1)-STEP(11, slen - 1), col, BF
    LINE (x1, y1)-STEP(11, 11), 0, B
    LINE (x1, y1 + slen - 12)-STEP(11, 11), 0, B
    PSET (x1 + 1, y1 + slen - 11): DRAW text$
    PSET (x1 + 1, y1 + 1): DRAW text$
    PSET (x1 + 8, y1 + slen - 8): DRAW "a0" + arrow$
    PSET (x1 + 3, y1 + 7): DRAW "a2" + arrow$
ELSE
    REM *** DRAW LEFT,RIGHT SCROLL BUTTON ***
    arrow$ = "c0 u5rd5 eu3f d"
    LINE (x1, y1)-STEP(slen - 1, 11), col, BF
    LINE (x1, y1)-STEP(11, 11), 0, B
    LINE (x1 + slen - 12, y1)-STEP(11, 11), 0, B
    PSET (x1 + 1, y1 + 1): DRAW text$
    PSET (x1 + slen - 11, y1 + 1): DRAW text$
    PSET (x1 + slen - 8, y1 + 8): DRAW "a0" + arrow$
    PSET (x1 + 7, y1 + 3): DRAW "a2" + arrow$
END IF
DRAW "a0"

END SUB

SUB showtextbox (tbx, tby, tbsx, textlen, BCOL)
REM **********************************
REM *** DISPLAY THE TEXTBOX        ***
REM **********************************
IF textlen = -1 THEN textlen = CINT((tbsx - 9) / (1 + maxclen + BOLD))
IF tbsx = -1 THEN tbsx = textlen * (maxclen + BOLD + 1) + 9
LINE (tbx, tby)-STEP(tbsx - 1, charhigh + 4), BCOL, BF
LINE (tbx, tby)-STEP(tbsx - 1, charhigh + 4), 15, B
LINE (tbx, tby)-STEP(tbsx - 1, 0), 8
LINE -STEP(0, charhigh + 4), 8

END SUB

SUB showvcmdbuttons (x1, y1, cbrangey, cbsx2, cblist$(), CBMAX, BCOL, fcol)

REM *** AUTO-SET BUTTON SIZE ***
IF cbsx2 = -1 THEN
    FOR g1 = 1 TO CBMAX
        IF tlen(cblist$(g1)) > cbsx2 THEN cbsx2 = tlen(cblist$(g1)) + 20
    NEXT
END IF

REM *** DRAW THE COMMAND BUTTONS FIRST - SIDE BY SIDE ***
IF CBMAX > 1 THEN
    REM *** DISPLAY MORE THAN ONE BUTTONS ***
    FOR gY33 = 0 TO CBMAX - 1
        gy34 = CINT(y1 + (gY33 * ((cbrangey - (charhigh + 8)) / (CBMAX - 1))))
        CALL cmdbutton(x1, gy34, cbsx2, cblist$(gY33 + 1), BCOL, fcol)
    NEXT
END IF

END SUB

SUB textcolor (tempcol)
textcol = tempcol

END SUB

FUNCTION tlen (ltext$)
REM *********************************************
REM *** CALCULATE LENGTH OF TEXT IN PIXELS   ****
REM *********************************************
g23 = LEN(ltext$) - 1

FOR g22 = 1 TO LEN(ltext$)
    c$ = MID$(ltext$, g22, 1)
    IF c$ = "&" THEN g23 = g23 - (CHARLEN(ASC(c$) - 32) + BOLD)
    g23 = g23 + CHARLEN(ASC(c$) - 32) + BOLD
NEXT
tlen = g23

END FUNCTION

SUB vscroll (x1, y1, slen, barlen, col, min, max, value)
REM ***********************************
REM ** UPDATES VERTICAL SCROLL      ***
REM ***********************************
DIM tempcol

REM ** UPDATE BAR SKELETON ***
LINE (x1, y1 + 12)-STEP(11, slen - 25), 24, BF
LINE (x1, y1 + 11)-STEP(10, slen - 24), 0, B
LINE (x1 + 1, y1 + 12)-STEP(10, slen - 25), 8, B
LINE (x1 + 1, y1 + 12)-STEP(0, slen - 25), 15
LINE -STEP(9, 0), 15

REM *** DRAW THE BAR POINTER ***
blen$ = STR$(barlen - 2)
aval = CINT((value - min) / (max - min) * (slen - 23 - barlen))
LINE (x1 + 1, y1 + 11 + aval)-STEP(9, barlen - 1), 0, B
PSET (x1 + 1, y1 + 11 + aval): DRAW "c15 r9 dd" + blen$ + " c8 l9 u" + blen$

REM ** SHADED BAR ***
FOR gx1 = 0 TO 3
    LINE (x1 + 5 - gx1, y1 + 12 + aval)-STEP(0, barlen - 3), col - gx1
    LINE (x1 + 6 + gx1, y1 + 12 + aval)-STEP(0, barlen - 3), col - gx1
NEXT


END SUB

